typedef struct {
  char status;
  int loc;
  int arg;
  int (*prog)(int loc);
} proc;

#define NUMPROCS 16

#define procsize (sizeof(proc))
#define procssize (NUMPROCS*procsize)
#define DEAD 0
#define RUNNING 1
#define WAITING 2
#define SLEEPING 3

int task1(int loc);

proc procs[NUMPROCS];

int currproc;

int main(int argc, char **argv)
{
  short x;

  for(x=0;x<NUMPROCS;++x)
  {
    procs[x].status=DEAD;
    procs[x].loc=-1;
    procs[x].arg=0;
  }
  procs[0].loc=0;
  procs[0].status=RUNNING;
  procs[0].prog=task1;
  procs[0].arg=1;
  while(1==1)
  {
    for(currproc=0;currproc<NUMPROCS;++currproc)
    {
      if(procs[currproc].status==RUNNING)
      {
/*        printf("Calling proc %d with loc %d\n",currproc,procs[currproc].loc);*/
        procs[currproc].loc=(*procs[currproc].prog)(procs[currproc].loc);
        if(procs[currproc].loc==-1)
        {
          procs[currproc].status=DEAD;
/*          printf("Process %d exited (loc was %d)\n",currproc,procs[currproc].loc);*/
        }
      } else if(procs[currproc].status==SLEEPING)
      {
        procs[currproc].arg--;
        if(procs[currproc].arg<=0)
          procs[currproc].status=RUNNING;
      } else if(procs[currproc].status==WAITING)
      {
        if(procs[procs[currproc].arg].status==DEAD)
          procs[currproc].status=RUNNING;
      }
    }
  }
}  
  
int dofork(void)
{
  int x,f;
  f=0;
  for(x=0;x<NUMPROCS;++x)
  {
    if(f==0)
    {
      if(procs[x].status==DEAD)
      {
/*        printf("Copying proc %d to proc %d\n",currproc,x);*/
        f=1;
        memcpy(&procs[x],&procs[currproc],procsize);
        procs[x].arg=0;
        procs[currproc].arg=x;
      }
    }
  }
  if(f==0)
  {
    procs[currproc].arg=-1;
    return -1;
  }
}

int task1x[NUMPROCS];

int task1(int loc)
{
  int oloc;
/*  printf("Called as task %d:%d\n",currproc,loc);*/
  if(loc==0)
  {
    if(procs[currproc].arg==1)
      dofork();
    printf("Task 1 started(%d)\n",currproc);
    oloc=1;
    task1x[currproc]=1;
  } else if(loc==1)
  {
    printf("Task 1(%d): %d\n",currproc,task1x[currproc]);
    task1x[currproc]++;
    if(task1x[currproc]<10)
      oloc=1;
     else
      oloc=-1;
  }
  return oloc;
}
